/*
 * Decompiled with CFR 0.152.
 */
package com.deepexi.scd.calculate.enums;

import com.google.common.collect.ImmutableList;
import java.math.BigDecimal;
import java.util.Objects;

public class CarbonDisclosure {

    public static enum EnergyCategoryEnum {
        COAL("COAL", "煤", new BigDecimal("0.03412")),
        OIL("OIL", "油", new BigDecimal("0.03412")),
        ELECTRICITY("ELECTRICITY", "电", new BigDecimal("0.1229")),
        GAS("GAS", "气", new BigDecimal("0.03412")),
        HEAT("HEAT", "热", new BigDecimal("0.03412")),
        INVALID_VALUE("", "非法值", new BigDecimal("0"));

        private String code;
        private String value;
        private BigDecimal coefficient;

        private EnergyCategoryEnum(String code, String value, BigDecimal coefficient) {
            this.code = code;
            this.value = value;
            this.coefficient = coefficient;
        }

        public String getCode() {
            return this.code;
        }

        public String getValue() {
            return this.value;
        }

        public BigDecimal getCoefficient() {
            return this.coefficient;
        }

        public static EnergyCategoryEnum match(String code) {
            EnergyCategoryEnum result = null;
            for (EnergyCategoryEnum s : EnergyCategoryEnum.values()) {
                if (!s.getCode().equals(code)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum FillTypeEnumforEsg {
        REPORT_TYPE(1, "报告年"),
        BASE_TYPE1(2, "基准年1"),
        BASE_TYPE2(3, "基准年2"),
        INVALID_VALUE_ESG(0, "非法值");

        private Integer key;
        private String value;

        private FillTypeEnumforEsg(Integer key, String value) {
            this.key = key;
            this.value = value;
        }

        public Integer getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static FillTypeEnumforEsg match(Integer key) {
            FillTypeEnumforEsg result = null;
            for (FillTypeEnumforEsg s : FillTypeEnumforEsg.values()) {
                if (!Objects.equals(s.getKey(), key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE_ESG;
            }
            return result;
        }
    }

    public static enum FillTypeEnum {
        REPORT_TYPE(1, "报告年"),
        BASE_TYPE(2, "基准年"),
        INVALID_VALUE(0, "非法值");

        private Integer key;
        private String value;

        private FillTypeEnum(Integer key, String value) {
            this.key = key;
            this.value = value;
        }

        public Integer getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static FillTypeEnum match(Integer key) {
            FillTypeEnum result = null;
            for (FillTypeEnum s : FillTypeEnum.values()) {
                if (!Objects.equals(s.getKey(), key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum ReportActivityEnum {
        FUEL_CONSUMPTION_EX_RAW_MATERIALS("1", "燃料消耗 (原料除外)"),
        ELECTRICITY_CONSUMPTION("2", "已购买或已获取电力的消耗"),
        THERMAL_ENERGY_CONSUMPTION("3", "已购买或已获取热能的消耗"),
        STEAM_ENERGY_CONSUMPTION("4", "已购买或已获取蒸汽能的消耗"),
        REFRIGERATION_ENERGY_CONSUMPTION("5", "已购买或已获取制冷能源的消耗"),
        INVALID_VALUE("0", "非法值");

        private String key;
        private String value;

        private ReportActivityEnum(String key, String value) {
            this.key = key;
            this.value = value;
        }

        public String getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static ReportActivityEnum match(String key) {
            ReportActivityEnum result = null;
            for (ReportActivityEnum s : ReportActivityEnum.values()) {
                if (!s.getKey().equals(key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum ReportStatusEnum {
        NOT_IMPROVED("1", "待完善"),
        REPORT_GENERATION_IN_PROGRESS("2", "报告生成中"),
        GENERATED("3", "已生成"),
        INVALID_VALUE("0", "非法值");

        private String key;
        private String value;

        private ReportStatusEnum(String key, String value) {
            this.key = key;
            this.value = value;
        }

        public String getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static ReportStatusEnum match(String key) {
            ReportStatusEnum result = null;
            for (ReportStatusEnum s : ReportStatusEnum.values()) {
                if (!s.getKey().equals(key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum EvaluationStatusEnum {
        NOPUBLIC("0", 0, "不披露"),
        RELATED_CALCULATED("1", 1, "相关，已计算"),
        RELATED_NOT_CALCULATED("2", 4, "相关，尚未计算"),
        UNRELATED_CALCULATED("3", 2, "不相关，已计算"),
        NOT_RELEVANT_EXPLANATION("4", 3, "不相关，提供解释"),
        NOT_EVALUATED("5", 5, "未评估"),
        INVALID_VALUE("", 99, "非法值");

        private String key;
        private String value;
        private int showInx;

        private EvaluationStatusEnum(String key, int showInx, String value) {
            this.key = key;
            this.value = value;
            this.showInx = showInx;
        }

        public int getShowInx() {
            return this.showInx;
        }

        public String getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static boolean calculate(String key) {
            return ImmutableList.of(EvaluationStatusEnum.RELATED_CALCULATED.key, EvaluationStatusEnum.UNRELATED_CALCULATED.key).contains(key);
        }

        public static EvaluationStatusEnum match(String key) {
            EvaluationStatusEnum result = null;
            for (EvaluationStatusEnum s : EvaluationStatusEnum.values()) {
                if (!s.getKey().equals(key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }

        public static EvaluationStatusEnum matchValue(String value) {
            EvaluationStatusEnum result = null;
            for (EvaluationStatusEnum s : EvaluationStatusEnum.values()) {
                if (!s.getValue().equals(value)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum latitudeTypeEnum {
        INVALID_VALUE("INVALID_VALUE", 1),
        N("N", 1),
        E("E", 1),
        S("S", 0),
        W("W", 0);

        private String key;
        private Integer value;

        private latitudeTypeEnum(String key, Integer value) {
            this.key = key;
            this.value = value;
        }

        public static boolean positive(String key) {
            return latitudeTypeEnum.N.key.equals(key) || latitudeTypeEnum.E.key.equals(key);
        }

        public static latitudeTypeEnum getByKey(String key) {
            for (latitudeTypeEnum value : latitudeTypeEnum.values()) {
                if (!value.getKey().equals(key)) continue;
                return value;
            }
            return null;
        }

        public String getKey() {
            return this.key;
        }

        public Integer getValue() {
            return this.value;
        }
    }

    public static enum CdpCalculateMethodEnum {
        INVALID_VALUE("0", null, 0),
        ONE("1", "供应商特定的方法", 0),
        TWO("2", "混合方法", 0),
        THREE("3", "平均数据方法", 0),
        FOUR("4", "基于支出的方法", 0),
        FIVE("5", "平均产品方法", 0),
        SIX("6", "平均基于支出的方法", 0),
        SEVEN("7", "基于燃料的方法", 0),
        EIGHT("8", "基于距离的方法", 0),
        NINE("9", "废物类型特定的方法", 0),
        TEN("10", "资产特定的方法", 0),
        ELEVEN("11", "租赁方特定的方法", 0),
        TWELVE("12", "现场特定的方法", 0),
        THIRTEEN("13", "直接阶段排放的方法", 1),
        FOURTEEN("14", "非直接阶段排放方法", 1),
        FIFTEEN("15", "特许经营特定方法", 0),
        SIXTEEN("16", "投资特定方法", 0),
        SEVENTEEN("17", "其他", 1);

        private String key;
        private String value;
        private Integer explain;

        private CdpCalculateMethodEnum(String key, String value, Integer explain) {
            this.key = key;
            this.value = value;
            this.explain = explain;
        }

        public static CdpCalculateMethodEnum getByKey(String key) {
            for (CdpCalculateMethodEnum value : CdpCalculateMethodEnum.values()) {
                if (!value.getKey().equals(key)) continue;
                return value;
            }
            return null;
        }

        public String getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public Integer getExplain() {
            return this.explain;
        }
    }

    public static enum YesOrNo {
        YES(1, "是", "是"),
        NO(2, "否", "无"),
        INVALID_VALUE(0, "非法值", "");

        private Integer key;
        private String value;
        private String remark;

        private YesOrNo(Integer key, String value, String remark) {
            this.key = key;
            this.value = value;
            this.remark = remark;
        }

        public Integer getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public String getRemark() {
            return this.remark;
        }

        public static YesOrNo match(Integer key) {
            YesOrNo result = null;
            for (YesOrNo s : YesOrNo.values()) {
                if (!s.getKey().equals(key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum RegionalDimensionTypeEnum {
        CONTINENTAL_DIMENSION(1, "大洲维度"),
        REGIONAL_DIMENSION(2, "国家/地区维度"),
        INVALID_VALUE(0, "非法值");

        private Integer key;
        private String value;

        private RegionalDimensionTypeEnum(Integer key, String value) {
            this.key = key;
            this.value = value;
        }

        public Integer getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static RegionalDimensionTypeEnum match(int key) {
            RegionalDimensionTypeEnum result = null;
            for (RegionalDimensionTypeEnum s : RegionalDimensionTypeEnum.values()) {
                if (s.getKey() != key) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum ExpandActivitiesTypeEnum {
        YES(1, "是"),
        NO(2, "否"),
        INVALID_VALUE(0, "非法值");

        private Integer key;
        private String value;

        private ExpandActivitiesTypeEnum(Integer key, String value) {
            this.key = key;
            this.value = value;
        }

        public Integer getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static ExpandActivitiesTypeEnum match(Integer key) {
            ExpandActivitiesTypeEnum result = null;
            for (ExpandActivitiesTypeEnum s : ExpandActivitiesTypeEnum.values()) {
                if (!s.getKey().equals(key)) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }

    public static enum ReportAutoCreateTypeEnum {
        AUTOMATIC(1, "自动"),
        HAND_MOVEMENT(2, "手动"),
        INVALID_VALUE(0, "非法值");

        private Integer key;
        private String value;

        private ReportAutoCreateTypeEnum(Integer key, String value) {
            this.key = key;
            this.value = value;
        }

        public Integer getKey() {
            return this.key;
        }

        public String getValue() {
            return this.value;
        }

        public static ReportAutoCreateTypeEnum match(int key) {
            ReportAutoCreateTypeEnum result = null;
            for (ReportAutoCreateTypeEnum s : ReportAutoCreateTypeEnum.values()) {
                if (s.getKey() != key) continue;
                result = s;
                break;
            }
            if (null == result) {
                return INVALID_VALUE;
            }
            return result;
        }
    }
}

